{
ZWECK       : Testprogramm fr TMultiCheckListBox

DATEIEN     : MultiCheckListBox.pas
              MultiCheckListBox_Test.dpr
              MultiCheckListBox_Test_MainForm.pas
              MultiCheckListBox_Test_MainForm.dfm

NDERUNGEN  : Feb.99  Version 1.0

AUTOR       : Kurt Spitzley, email Kurt.Spitzley@rz-online.de oder
                                   101.10490@germanynet.de

COPYRIGHT   : (c) 1998 bei Kurt Spitzley
              Diese Software darf zu nichtkommerziellen Zwecken frei genutzt
              und weitergegeben werden.
GEWHR-
LEISTUNG    : Sie akzeptieren diese Software wie sie ist, ohne eine Garantie
              jeglicher Art, einschlielich aber nicht ausschlielich der
              Eignung fr eine beliebige Anwendung.

BESCHREIBUNG: s.o.

================================================================================

SCOPE       : Testprogram for TMultiCheckListBox

FILES       : MultiCheckListBox.pas
              MultiCheckListBox_Test.dpr
              MultiCheckListBox_Test_MainForm.pas
              MultiCheckListBox_Test_MainForm.dfm

LAST CHANGES: V1.0 Feb.99

AUTHOR      : Kurt Spitzley, email Kurt.Spitzley@rz-online.de or
                                   101.10490@germanynet.de
              Derived from Patrick Brisacier's TCheckListBox component

COPYRIGHT   : (c) 1998 by Kurt Spitzley, All rights reserved.
              This software should not be SOLD by anyone. It is distributed as
              freeware and therefore may be used free of charge.

DISCLAIMER  : You accept this software AS IS without any representation or
              warranty of any kind, including but not limited to the warranty of
              merchantability or fitness for a particular purpose.
}

unit MultiCheckListBox_MainForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  stdctrls, ExtCtrls, MultiCheckListBox, CheckLst;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    edItemIndex: TEdit;
    edCheckBox: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    btnWriteState: TButton;
    btnReadValue: TButton;
    rgListbox: TRadioGroup;
    lblReadValue: TLabel;
    rgState: TRadioGroup;
    rgChecked: TRadioGroup;
    btnWriteChecked: TButton;
    Label3: TLabel;
    lblClickedOn: TLabel;
    procedure FormDestroy(Sender: TObject);
    procedure btnReadValueClick(Sender: TObject);
    procedure rgListboxClick(Sender: TObject);
    procedure btnWriteStateClick(Sender: TObject);
    procedure btnWriteCheckedClick(Sender: TObject);
  private
    UpperListBox,LowerListBox,lb: TMultiCheckListBox;
    procedure CheckBoxClickListBox(Sender: TObject; IdxItem, IdxCheckBox: integer;
                                   Checked: boolean;
                                   State: TCheckBoxState);
  public
    constructor Create(AOwner: TComponent); override;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const
  tf  : array[boolean] of string =('FALSE','TRUE');
  cbs : array[TCheckBoxState] of string =('Unchecked','Checked','Grayed');

constructor TForm1.Create(AOwner: TComponent);
var
  w:word;
begin
  inherited;

  UpperListBox:= TMultiCheckListBox.MultiCreate(self,11);
  UpperListBox.Parent:=Panel2;
  UpperListBox.Height:= 200;
  UpperListBox.align:=alClient;
  UpperListBox.Offset:= 10;  // defines space between checkboxes

  // Get Checkbox-clicking by using this event
  UpperListBox.OnCheckBoxClick:=CheckBoxClickListBox;

  // AddItem adds text and the state of the checkboxes in an open array
  for w := 1 to 30 do
   UpperListBox.AddItem('Testtext '+IntToStr(w),
     [true, false, true, false, true, false, true, false, true, false, true ]);

  LowerListBox:= TMultiCheckListBox.MultiCreate(self,4);
  LowerListBox.Parent:=Panel4;
  LowerListBox.Color:= clAqua;
  LowerListBox.align:=alClient;
  LowerListBox.AllowGrayed:=true;
  LowerListBox.Offset:= 40;

  // use some event-handling-procedure as for upper listbox
  LowerListBox.OnCheckBoxClick:=CheckBoxClickListBox;

  for w := 1 to 30 do
   LowerListBox.AddItem('Testtext '+IntToStr(w),
     [false, true, false, true]);

  lb:= UpperListBox;     
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  UpperListBox.Free;
  LowerListBox.Free;
end;

procedure TForm1.btnReadValueClick(Sender: TObject);
begin
  lblReadValue.Caption:=
    tf[lb.Checked[StrToInt(edItemIndex.Text), StrToInt(edCheckBox.Text)]];
end;

procedure TForm1.rgListboxClick(Sender: TObject);
begin
 if rgListBox.ItemIndex=0 then
   lb:=UpperListBox
 else
   lb:=LowerListBox
end;

procedure TForm1.btnWriteStateClick(Sender: TObject);
begin
  case rgState.ItemIndex of
    0: lb.State[StrToInt(edItemIndex.Text), StrToInt(edCheckBox.Text)]:=cbChecked;
    1: lb.State[StrToInt(edItemIndex.Text), StrToInt(edCheckBox.Text)]:=cbUnchecked;
    2: lb.State[StrToInt(edItemIndex.Text), StrToInt(edCheckBox.Text)]:=cbGrayed;
  end;
end;

procedure TForm1.btnWriteCheckedClick(Sender: TObject);
begin
  case rgChecked.ItemIndex of
    0: lb.Checked[StrToInt(edItemIndex.Text), StrToInt(edCheckBox.Text)]:=true;
    1: lb.Checked[StrToInt(edItemIndex.Text), StrToInt(edCheckBox.Text)]:=false;
  end;
end;

procedure TForm1.CheckBoxClickListBox(Sender: TObject; IdxItem, IdxCheckBox: integer;
                                      Checked: boolean;
                                      State: TCheckBoxState);
begin
  lblClickedOn.Caption:=format('Row: %2d  CBox: %2d   Checked: %6s   State: %s',
    [IdxItem, IdxCheckBox, tf[Checked], cbs[State]]);
end;

end.
